3 # Copyright (c) 2005, 2006 Junio C Hamano
9 git am [options] [(<mbox>|<Maildir>)...]
10 git am [options] (--continue | --skip | --abort)
12 i,interactive run interactively
13 b,binary* (historical option -- no-op)
14 3,3way allow fall back on 3way merging if needed
16 s,signoff add a Signed-off-by line to the commit message
17 u,utf8 recode into utf8 (default)
18 k,keep pass -k flag to git-mailinfo
19 keep-non-patch pass -b flag to git-mailinfo
20 m,message-id pass -m flag to git-mailinfo
21 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
22 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
23 c,scissors strip everything before a scissors line
24 whitespace= pass it through git-apply
25 ignore-space-change pass it through git-apply
26 ignore-whitespace pass it through git-apply
27 directory= pass it through git-apply
28 exclude= pass it through git-apply
29 include= pass it through git-apply
30 C= pass it through git-apply
31 p= pass it through git-apply
32 patch-format= format the patch(es) are in
33 reject pass it through git-apply
34 resolvemsg= override error message when patch failure occurs
35 continue continue applying patches after resolving a conflict
36 r,resolved synonyms for --continue
37 skip skip the current patch
38 abort restore the original branch and abort the patching operation.
39 committer-date-is-author-date lie about committer date
40 ignore-date use current timestamp for author date
41 rerere-autoupdate update the index with reused conflict resolution if possible
42 S,gpg-sign? GPG-sign commits
43 rebasing* (internal use for git-rebase)"
47 prefix=$(git rev-parse --show-prefix)
52 git var GIT_COMMITTER_IDENT >/dev/null ||
53 die "$(gettext "You need to set your committer info first")"
55 if git rev-parse --verify -q HEAD >/dev/null
63 if test '' != "$interactive"
67 if test '' != "$threeway"
72 empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
75 git rev-parse --sq-quote "$@"
79 echo "$1" >"$dotest/next"
80 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
85 if test -f "$dotest/dirtyindex"
90 if ! test -f "$dotest/abort-safety"
95 abort_safety=$(cat "$dotest/abort-safety")
96 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
100 gettextln "You seem to have moved HEAD since the last 'am' failure.
101 Not rewinding to ORIG_HEAD" >&2
105 stop_here_user_resolve () {
106 if [ -n "$resolvemsg" ]; then
107 printf '%s\n' "$resolvemsg"
110 eval_gettextln "When you have resolved this problem, run \"\$cmdline --continue\".
111 If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
112 To restore the original branch and stop patching, run \"\$cmdline --abort\"."
118 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
119 "$dotest/patch" "$dotest/info"
120 echo "$next" >"$dotest/next"
126 gettextln "Cannot fall back to three-way merge."
131 O_OBJECT=$(cd "$GIT_OBJECT_DIRECTORY" && pwd)
133 rm -fr "$dotest"/patch-merge-*
134 mkdir "$dotest/patch-merge-tmp-dir"
136 # First see if the patch records the index info that we can use.
137 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
138 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
140 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
141 git write-tree >"$dotest/patch-merge-base+" ||
142 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
144 say "$(gettext "Using index info to reconstruct a base tree...")"
146 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
148 if test -z "$GIT_QUIET"
150 eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
153 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
156 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
157 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
159 cannot_fallback "$(gettext "Did you hand edit your patch?
160 It does not apply to blobs recorded in its index.")"
163 test -f "$dotest/patch-merge-index" &&
164 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
165 orig_tree=$(cat "$dotest/patch-merge-base") &&
166 rm -fr "$dotest"/patch-merge-* || exit 1
168 say "$(gettext "Falling back to patching base and 3-way merge...")"
170 # This is not so wrong. Depending on which base we picked,
171 # orig_tree may be wildly different from ours, but his_tree
172 # has the same set of wildly different changes in parts the
173 # patch did not touch, so recursive ends up canceling them,
174 # saying that we reverted all those changes.
176 eval GITHEAD_$his_tree='"$FIRSTLINE"'
177 export GITHEAD_$his_tree
178 if test -n "$GIT_QUIET"
180 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
182 our_tree=$(git rev-parse --verify -q HEAD || echo $empty_tree)
183 git-merge-recursive $orig_tree -- $our_tree $his_tree || {
184 git rerere $allow_rerere_autoupdate
185 die "$(gettext "Failed to merge in the changes.")"
187 unset GITHEAD_$his_tree
191 test $# = 0 || echo >&2 "$@"
198 check_patch_format () {
199 # early return if patch_format was set from the command line
200 if test -n "$patch_format"
205 # we default to mbox format if input is from stdin and for
207 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
213 # otherwise, check the first few non-blank lines of the first
214 # patch to try to detect its format
216 # Start from first line containing non-whitespace
225 "From "* | "From: "*)
228 '# This series applies on GIT commit'*)
229 patch_format=stgit-series
231 "# HG changeset patch")
235 # if the second line is empty and the third is
236 # a From, Author or Date entry, this is very
237 # likely an StGIT patch
239 ,"From: "* | ,"Author: "* | ,"Date: "*)
247 if test -z "$patch_format" &&
252 # This begins with three non-empty lines. Is this a
253 # piece of e-mail a-la RFC2822? Grab all the headers,
254 # discarding the indented remainder of folded lines,
255 # and see if it looks like that they all begin with the
256 # header field names...
258 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
259 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
262 } < "$1" || clean_abort
266 case "$patch_format" in
268 if test t = "$keepcr"
274 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
280 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
282 series_dir=$(dirname "$1")
289 set "$@" "$series_dir/$filename"
291 # remove the safety x
293 # remove the arg coming from the first-line comment
295 } < "$series_file" || clean_abort
296 # set the patch format appropriately
298 # now handle the actual StGIT patches
303 test 0 -eq "$#" && set -- -
306 this=$(expr "$this" + 1)
307 msgnum=$(printf "%0${prec}d" $this)
308 # Perl version of StGIT parse_patch. The first nonemptyline
309 # not starting with Author, From or Date is the
310 # subject, and the body starts with the next nonempty
311 # line not starting with Author, From or Date
312 @@PERL@@ -ne 'BEGIN { $subject = 0 }
313 if ($subject > 1) { print ; }
314 elsif (/^\s+$/) { next ; }
315 elsif (/^Author:/) { s/Author/From/ ; print ;}
316 elsif (/^(From|Date)/) { print ; }
322 print "Subject: ", $_ ;
325 ' -- "$stgit" >"$dotest/$msgnum" || clean_abort
327 echo "$this" > "$dotest/last"
333 test 0 -eq "$#" && set -- -
336 this=$(( $this + 1 ))
337 msgnum=$(printf "%0${prec}d" $this)
338 # hg stores changeset metadata in #-commented lines preceding
339 # the commit message and diff(s). The only metadata we care about
340 # are the User and Date (Node ID and Parent are hashes which are
341 # only relevant to the hg repository and thus not useful to us)
342 # Since we cannot guarantee that the commit message is in
343 # git-friendly format, we put no Subject: line and just consume
344 # all of the message as the body
345 LANG=C LC_ALL=C @@PERL@@ -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
346 if ($subject) { print ; }
347 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
348 elsif (/^\# Date /) {
349 my ($hashsign, $str, $time, $tz) = split ;
350 $tz_str = sprintf "%+05d", (0-$tz)/36;
352 strftime("%a, %d %b %Y %H:%M:%S ",
355 } elsif (/^\# /) { next ; }
360 ' -- "$hg" >"$dotest/$msgnum" || clean_abort
362 echo "$this" >"$dotest/last"
367 if test -n "$patch_format"
369 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
371 clean_abort "$(gettext "Patch format detection failed.")"
378 dotest="$GIT_DIR/rebase-apply"
379 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
380 messageid= resolvemsg= resume= scissors= no_inbody_headers=
382 committer_date_is_author_date=
384 allow_rerere_autoupdate=
388 if test "$(git config --bool --get am.messageid)" = true
393 if test "$(git config --bool --get am.keepcr)" = true
404 gettextln >&2 "The -b/--binary option has been a no-op for long time, and
405 it will be removed. Please do not use it anymore."
412 utf8=t ;; # this is now default
427 -r|--resolved|--continue)
434 rebasing=t threeway=t ;;
436 resolvemsg="${1#--resolvemsg=}" ;;
437 --whitespace=*|--directory=*|--exclude=*|--include=*)
438 git_apply_opt="$git_apply_opt $(sq "$1")" ;;
440 git_apply_opt="$git_apply_opt $(sq "$1")" ;;
442 patch_format="${1#--patch-format=}" ;;
443 --reject|--ignore-whitespace|--ignore-space-change)
444 git_apply_opt="$git_apply_opt $1" ;;
445 --committer-date-is-author-date)
446 committer_date_is_author_date=t ;;
449 --rerere-autoupdate|--no-rerere-autoupdate)
450 allow_rerere_autoupdate="$1" ;;
460 gpg_sign_opt="-S${1#--gpg-sign=}" ;;
469 # If the dotest directory exists, but we have finished applying all the
470 # patches in them, clear it out.
471 if test -d "$dotest" &&
472 test -f "$dotest/last" &&
473 test -f "$dotest/next" &&
474 last=$(cat "$dotest/last") &&
475 next=$(cat "$dotest/next") &&
477 test "$next" -gt "$last"
482 if test -d "$dotest" && test -f "$dotest/last" && test -f "$dotest/next"
484 case "$#,$skip$resolved$abort" in
486 # Explicit resume command and we do not have file, so
490 # No file input but without resume parameters; catch
491 # user error to feed us a patch from standard input
492 # when there is already $dotest. This is somewhat
493 # unreliable -- stdin could be /dev/null for example
494 # and the caller did not intend to feed us a patch but
495 # wanted to continue unattended.
502 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
505 case "$skip,$abort" in
507 die "$(gettext "Please make up your mind. --skip or --abort?")"
511 head_tree=$(git rev-parse --verify -q HEAD || echo $empty_tree) &&
512 git read-tree --reset -u $head_tree $head_tree &&
513 index_tree=$(git write-tree) &&
514 git read-tree -m -u $index_tree $head_tree
515 git read-tree $head_tree
518 if test -f "$dotest/rebasing"
520 exec git rebase --abort
525 head_tree=$(git rev-parse --verify -q HEAD || echo $empty_tree) &&
526 git read-tree --reset -u $head_tree $head_tree &&
527 index_tree=$(git write-tree) &&
528 orig_head=$(git rev-parse --verify -q ORIG_HEAD || echo $empty_tree) &&
529 git read-tree -m -u $index_tree $orig_head
530 if git rev-parse --verify -q ORIG_HEAD >/dev/null 2>&1
534 git read-tree $empty_tree
535 curr_branch=$(git symbolic-ref HEAD 2>/dev/null) &&
536 git update-ref -d $curr_branch
542 rm -f "$dotest/dirtyindex"
544 # Possible stray $dotest directory in the independent-run
545 # case; in the --rebasing case, it is upto the caller
546 # (git-rebase--am) to take care of stray directories.
547 if test -d "$dotest" && test -z "$rebasing"
549 case "$skip,$resolved,$abort" in
555 die "$(eval_gettext "Stray \$dotest directory found.
556 Use \"git am --abort\" to remove it.")"
561 # Make sure we are not given --skip, --continue, or --abort
562 test "$skip$resolved$abort" = "" ||
563 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
566 mkdir -p "$dotest" || exit
568 if test -n "$prefix" && test $# != 0
573 test -n "$first" && {
577 if is_absolute_path "$arg"
581 set "$@" "$prefix$arg"
587 check_patch_format "$@"
591 # -i can and must be given when resuming; everything
593 echo " $git_apply_opt" >"$dotest/apply-opt"
594 echo "$threeway" >"$dotest/threeway"
595 echo "$sign" >"$dotest/sign"
596 echo "$utf8" >"$dotest/utf8"
597 echo "$keep" >"$dotest/keep"
598 echo "$messageid" >"$dotest/messageid"
599 echo "$scissors" >"$dotest/scissors"
600 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
601 echo "$GIT_QUIET" >"$dotest/quiet"
602 echo 1 >"$dotest/next"
603 if test -n "$rebasing"
605 : >"$dotest/rebasing"
607 : >"$dotest/applying"
608 if test -n "$HAS_HEAD"
610 git update-ref ORIG_HEAD HEAD
612 git update-ref -d ORIG_HEAD >/dev/null 2>&1
617 git update-index -q --refresh
623 files=$(git ls-files) ;;
625 files=$(git diff-index --cached --name-only HEAD --) ;;
629 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
630 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
634 # Now, decide what command line options we will give to the git
635 # commands we invoke, based on the result of parsing command line
636 # options and previous invocation state stored in $dotest/ files.
638 if test "$(cat "$dotest/utf8")" = t
644 keep=$(cat "$dotest/keep")
653 case "$(cat "$dotest/messageid")" in
659 case "$(cat "$dotest/scissors")" in
661 scissors=--scissors ;;
663 scissors=--no-scissors ;;
665 if test "$(cat "$dotest/no_inbody_headers")" = t
667 no_inbody_headers=--no-inbody-headers
671 if test "$(cat "$dotest/quiet")" = t
675 if test "$(cat "$dotest/threeway")" = t
679 git_apply_opt=$(cat "$dotest/apply-opt")
680 if test "$(cat "$dotest/sign")" = t
682 SIGNOFF=$(git var GIT_COMMITTER_IDENT | sed -e '
684 s/^/Signed-off-by: /'
690 last=$(cat "$dotest/last")
691 this=$(cat "$dotest/next")
694 this=$(expr "$this" + 1)
698 while test "$this" -le "$last"
700 msgnum=$(printf "%0${prec}d" $this)
701 next=$(expr "$this" + 1)
702 test -f "$dotest/$msgnum" || {
708 # If we are not resuming, parse and extract the patch information
709 # into separate files:
710 # - info records the authorship and title
711 # - msg is the rest of commit log message
712 # - patch is the patch body.
714 # When we are resuming, these files are either already prepared
715 # by the user, or the user can tell us to do so by --continue flag.
718 if test -f "$dotest/rebasing"
720 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
721 -e q "$dotest/$msgnum") &&
722 test "$(git cat-file -t "$commit")" = commit ||
724 git cat-file commit "$commit" |
725 sed -e '1,/^$/d' >"$dotest/msg-clean"
726 echo "$commit" >"$dotest/original-commit"
727 get_author_ident_from_commit "$commit" >"$dotest/author-script"
728 git diff-tree --root --binary --full-index "$commit" >"$dotest/patch"
730 git mailinfo $keep $no_inbody_headers $messageid $scissors $utf8 "$dotest/msg" "$dotest/patch" \
731 <"$dotest/$msgnum" >"$dotest/info" ||
734 # skip pine's internal folder data
735 sane_grep '^Author: Mail System Internal Data$' \
736 <"$dotest"/info >/dev/null &&
739 test -s "$dotest/patch" || {
740 eval_gettextln "Patch is empty. Was it split wrong?
741 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
742 To restore the original branch and stop patching run \"\$cmdline --abort\"."
745 rm -f "$dotest/original-commit" "$dotest/author-script"
747 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
751 git stripspace > "$dotest/msg-clean"
756 if test -f "$dotest/author-script"
758 eval $(cat "$dotest/author-script")
760 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
761 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
762 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
765 if test -z "$GIT_AUTHOR_EMAIL"
767 gettextln "Patch does not have a valid e-mail address."
771 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
775 if test '' != "$SIGNOFF"
777 LAST_SIGNED_OFF_BY=$(
778 sed -ne '/^Signed-off-by: /p' \
779 "$dotest/msg-clean" |
783 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
784 test '' = "$LAST_SIGNED_OFF_BY" && echo
791 if test -s "$dotest/msg-clean"
793 cat "$dotest/msg-clean"
795 if test '' != "$ADD_SIGNOFF"
799 } >"$dotest/final-commit"
802 case "$resolved$interactive" in
804 # This is used only for interactive view option.
805 git diff-index -p --cached HEAD -- >"$dotest/patch"
811 if test "$interactive" = t
814 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
816 while test "$action" = again
818 gettextln "Commit Body is:"
819 echo "--------------------------"
820 cat "$dotest/final-commit"
821 echo "--------------------------"
822 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
823 # in your translation. The program will only accept English
824 # input at this point.
825 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
829 [aA]*) action=yes interactive= ;;
830 [nN]*) action=skip ;;
831 [eE]*) git_editor "$dotest/final-commit"
834 git_pager "$dotest/patch" ;;
842 if test $action = skip
848 hook="$(git rev-parse --git-path hooks/applypatch-msg)"
851 "$hook" "$dotest/final-commit" || stop_here $this
854 if test -f "$dotest/final-commit"
856 FIRSTLINE=$(sed 1q "$dotest/final-commit")
861 say "$(eval_gettext "Applying: \$FIRSTLINE")"
865 # When we are allowed to fall back to 3-way later, don't give
866 # false errors during the initial attempt.
868 if test "$threeway" = t
870 squelch='>/dev/null 2>&1 '
872 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
876 # Resolved means the user did all the hard work, and
877 # we do not have to do any patch application. Just
878 # trust what the user has in the index file and the
881 git diff-index --quiet --cached HEAD -- && {
882 gettextln "No changes - did you forget to use 'git add'?
883 If there is nothing left to stage, chances are that something else
884 already introduced the same changes; you might want to skip this patch."
885 stop_here_user_resolve $this
887 unmerged=$(git ls-files -u)
888 if test -n "$unmerged"
890 gettextln "You still have unmerged paths in your index
891 did you forget to use 'git add'?"
892 stop_here_user_resolve $this
899 if test $apply_status != 0 && test "$threeway" = t
903 # Applying the patch to an earlier tree and merging the
904 # result may have produced the same tree as ours.
905 git diff-index --quiet --cached HEAD -- && {
906 say "$(gettext "No changes -- Patch already applied.")"
910 # clear apply_status -- we have successfully merged.
914 if test $apply_status != 0
916 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
917 if test "$(git config --bool advice.amworkdir)" != false
919 eval_gettextln 'The copy of the patch that failed is found in:
922 stop_here_user_resolve $this
925 hook="$(git rev-parse --git-path hooks/pre-applypatch)"
928 "$hook" || stop_here $this
931 tree=$(git write-tree) &&
933 if test -n "$ignore_date"
937 parent=$(git rev-parse --verify -q HEAD) ||
938 say >&2 "$(gettext "applying to an empty history")"
940 if test -n "$committer_date_is_author_date"
942 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
943 export GIT_COMMITTER_DATE
945 git commit-tree ${parent:+-p} $parent ${gpg_sign_opt:+"$gpg_sign_opt"} $tree \
946 <"$dotest/final-commit"
948 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
951 if test -f "$dotest/original-commit"; then
952 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
955 hook="$(git rev-parse --git-path hooks/post-applypatch)"
956 test -x "$hook" && "$hook"
961 if test -s "$dotest"/rewritten; then
962 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
963 hook="$(git rev-parse --git-path hooks/post-rewrite)"
964 if test -x "$hook"; then
965 "$hook" rebase < "$dotest"/rewritten
969 # If am was called with --rebasing (from git-rebase--am), it's up to
970 # the caller to take care of housekeeping.
971 if ! test -f "$dotest/rebasing"